<?php

   //-------- YAPS Options : START
   $yapservice = "yaps.mine.nu";    // Location where the yaps Service is located
   $secure     = true;             // change it to false if You wan't use SSL
   //-------- YAPS Options : END
   
   //-------- YAPS Check function : START 
   function yapsCheck($remotehost, $dns, $ssl = false){
      
      $http_response = "";
      $payserver = false;
      $host = "http://".$remotehost.":8080";
      $protocol = "";
      srand(microtime()*1000000);
      $random = rand(1,100000);
      $hash   = md5($random);

      if($ssl == true){
        $host = "https://".$remotehost.":4433";
        $protocol = "ssl://";
      }
      
      $link = sprintf("%s/?download=%s", $host, $hash);
      $url = parse_url($link);
      
      $fp = fsockopen($protocol.$url['host'], $url['port'], $err_num, $err_msg, 30) or die("Socket-open failed--error: ".$err_num." ".$err_msg);
      fputs($fp, "GET /".$url['path']."?".$url['query']." HTTP/1.0\n");
      fputs($fp, "User-agent: ".$hash."\r\n");
      fputs($fp, "Connection: close\n\n");
      while(!feof($fp)) {
          $http_response = fgets($fp, 128);
          
          $yapsDNS = explode(".", $http_response);
          $myDNS   = explode(".", $dns);
          if(($yapsDNS[0] == $myDNS[0]) && similar_text($http_response, $dns) > 12){
            $payserver = true;
            break;
          }
      }
      fclose($fp);
      
      switch($payserver){
        case true : return "<a href=\"".$host."/?q=".$dns."\" target=\"_blank\"><font color=\"red\">! Risk !</font></A>";
          break;
        case false : return "<font color=#5EFB6E>OK</font>";
          break;
        default : return "Unknow Error";
      }
      
   }
   //-------- YAPS Check function : END   
  
   //-------- YAPS Stats-Request function : START   
   function yapsStats($remotehost, $action, $ssl = false){
      
      $http_response = "";
      $host = "http://".$remotehost.":8080";
      $protocol = "";
      
      if($ssl == true){
        $host = "https://".$remotehost.":4433";
        $protocol = "ssl://";
      }
      
      
      $link = sprintf("%s/?q=&action=%s", $host, $action);
      $url = parse_url($link);
      $fp = fsockopen($protocol.$url['host'], $url['port'], $err_num, $err_msg, 30) or die("Socket-open failed--error: ".$err_num." ".$err_msg);
      fputs($fp, "GET /".$url['path']."?".$url['query']." HTTP/1.0\n");
      fputs($fp, "User-agent: YaPS 1.0\r\n");
      fputs($fp, "Connection: close\n\n");
      while(!feof($fp)) {
        $http_response = fgets($fp, 128);
      }
      fclose($fp);
      
      return htmlentities($http_response);
   }
   //-------- YAPS Stats-Request function : END
   
   
   include "common.php";
   include "meniu.php";
   
   $secure == true ? $sslstatus = "enabled" : $sslstatus = "disabled";
   
   format1("Yet Another Payserver Service", "v1.0");
   format1("Database version", yapsStats($yapservice, "date", $secure));
   format1("Database rows", yapsStats($yapservice, "rows", $secure));
   format1("Payserver hits", yapsStats($yapservice, "hits", $secure));
   format1("Secure connection", $sslstatus);
   loadServersHosts();
   ksort($ServerHost_Conectat);
   echo "<br />";	  
   echo "<table border=0 cellpadding=1 cellspacing=1>";
   echo "<tr>";
	 echo "<td width=250 class=\"Node_ID\">Server</td>";
	 echo "<td width=50 class=\"Node_ID\">Status</td>";
	 echo "</tr>";
   echo "</table>"; 
   
   $oldserver = "";
   foreach ($ServerHost_Conectat as $sh_host => $server_Time)
   {
      ob_flush();
      flush();
      
      list($host_DNS, $host_PORT) = explode(":", $sh_host);
      $newserver = $host_DNS;

      if($newserver != $oldserver){

        if ($host_PORT > 0)
        {
          $yaps = yapsCheck($yapservice, $host_DNS, $secure);
  	      usleep(100000);
  	    }
  	    echo "<table border=0 cellpadding=1 cellspacing=1>";
     		echo "<tr>";
  	    echo "<td width=250 class=\"Node_ID\"><A HREF=".$pagina."?nodeDns=$sh_host>".$sh_host."</A></td>";	
  	    echo "<td width=50 class=\"tabel_normal\">".$yaps."</td>";
  	    echo "</tr>";
  	    echo "</table>";
  	  }
  	  
	    $oldserver = $newserver;
   }
   

	 ENDPage();
?>
